diff -u arc2/ac.scm arc3/ac.scm
--- arc2/ac.scm	2008-02-24 19:38:13.000000000 -0500
+++ arc3/ac.scm	2009-05-30 17:09:15.000000000 -0400
@@ -1,50 +1,11 @@
-; scheme48
-; ,open tables sockets extended-ports c-system-function ascii i/o-internal 
-; ,open posix-files handle random pp simple-conditions
-
-; to do:
-; select, perhaps with threads, or pltt events
-; check argument count for complex arguments
-
-; refs.arc, first 300 lines of x, total CPU time including startup. on powerbook.
-; scheme48: 31.944u 0.518s 2:13.65 24.2%    0+0k 5+7io 0pf+0w
-; mzscheme: 16.425u 0.489s 0:52.61 32.1%    0+0k 26+22io 0pf+0w
-
-; dynamic creation of local variables with =
-;   can you create globals inside a procedure? 
-;   does action of = depend on whether, at run time,
-;     the variable has a global definition?
-;   what's the scope of such a variable?
-;   though a.lisp seems to create a global, not a local!
-; run-time expansion of macros
-; how do I know if something is a macro at compile time?
-; macros have lexical scope. so how do i know if a lexical
-;   variable is going to be bound to a procedure? or to a macro?
-; what is annotate doing to symbols?
-; tests.arc implies that '(a b) produces a mutable list
-;   so (fn () '(a)) produces a list that can be modified,
-;     and future calls will reflect the modifications
-;   oy. clisp works this way too.
-;   it's not that easy to simulate this.
-; what is this? (def foo1 (x (o y x)) (list x y))
-
-; it's not clear I translate NILs in the outputs of macros correctly.
-;   I translate (NIL . NIL) to ('NIL . '())
-; I use Scheme apply to call macros.
-;   Scheme apply demands a '()-terminated list.
-;   most macros have a . body argument.
-;   so body is '()-terminated, not NIL-terminated.
-;   solution: ar-false? knows about '()
-; this doesn't work, since var isn't a variable name:
-; (mac or args
-;   (and args
-;        (let var (tag 'symbol (list 'or))
-;          (list 'let var (car args)
-;                (list 'if var var (cons 'or (cdr args)))))))
+; Arc Compiler
 
 (module ac mzscheme
 
 (provide (all-defined))
+; uncomment the following require for mzscheme-4.x
+; much of Arc will work, but not mutable cons pairs.
+; (require rnrs/mutable-pairs-6)
 (require (lib "port.ss"))
 (require (lib "process.ss"))
 (require (lib "pretty.ss"))
@@ -65,9 +26,11 @@
         ((eq? (xcar s) 'quasiquote) (ac-qq (cadr s) env))
         ((eq? (xcar s) 'if) (ac-if (cdr s) env))
         ((eq? (xcar s) 'fn) (ac-fn (cadr s) (cddr s) env))
-        ((eq? (xcar s) 'set) (ac-set (cdr s) env))
-        ; this line could be removed without changing semantics
+        ((eq? (xcar s) 'assign) (ac-set (cdr s) env))
+        ; the next two clauses could be removed without changing semantics
         ((eq? (xcar (xcar s)) 'compose) (ac (decompose (cdar s) (cdr s)) env))
+        ((eq? (xcar (xcar s)) 'complement) 
+         (ac (list 'no (cons (cadar s) (cdr s))) env))
         ((pair? s) (ac-call (car s) (cdr s) env))
         (#t (err "Bad object in expression" s))))
 
@@ -80,14 +43,15 @@
 
 (define (ssyntax? x)
   (and (symbol? x)
-       (not (or (eqv? x '+) (eqv? x '++)))
+       (not (or (eqv? x '+) (eqv? x '++) (eqv? x '_)))
        (let ((name (symbol->string x)))
          (has-ssyntax-char? name (- (string-length name) 1)))))
 
 (define (has-ssyntax-char? string i)
   (and (>= i 0)
        (or (let ((c (string-ref string i)))
-             (or (eqv? c #\:) (eqv? c #\~) (eqv? c #\.) (eqv? c #\!)))
+             (or (eqv? c #\:) (eqv? c #\~) ;(eqv? c #\_) 
+                 (eqv? c #\.)  (eqv? c #\!)))
            (has-ssyntax-char? string (- i 1)))))
 
 (define (read-from-string str)
@@ -96,8 +60,13 @@
       (close-input-port port)
       val)))
 
+; Though graphically the right choice, can't use _ for currying
+; because then _!foo becomes a function.  Maybe use <>.  For now
+; leave this off and see how often it would have been useful.
+
 (define (expand-ssyntax sym)
   ((cond ((or (insym? #\: sym) (insym? #\~ sym)) expand-compose)
+     ;   ((insym? #\_ sym) expand-curry)
          ((or (insym? #\. sym) (insym? #\! sym)) expand-sexpr)
          (#t (error "Unknown ssyntax" sym)))
    sym))
@@ -118,28 +87,64 @@
         (car elts)
         (cons 'compose elts))))
 
-(define (expand-sexpr sym)
-  (build-sexpr (tokens (lambda (c) (or (eqv? c #\.) (eqv? c #\!)))
-                       (symbol->chars sym)
-                       '()
-                       '()
-                       #t)))
-
-; no error-checking!
+; How to include quoted arguments?  Can't treat all as quoted, because 
+; never want to quote fn given as first.  Do we want to allow quote chars 
+; within symbols?  Could be ugly.  
+
+; If release, fix the fact that this simply uses v0... as vars.  Should
+; make these vars gensyms.
+
+(define (expand-curry sym)
+  (let ((expr (exc (map (lambda (x) 
+                          (if (pair? x) (chars->value x) x))
+                        (tokens (lambda (c) (eqv? c #\_)) 
+                                (symbol->chars sym) 
+                                '() 
+                                '() 
+                                #t))
+                    0)))
+    (list 'fn 
+          (keep (lambda (s) 
+                  (and (symbol? s) 
+                       (eqv? (string-ref (symbol->string s) 0) 
+                             #\v)))
+                expr)
+          expr)))
+
+(define (keep f xs)
+  (cond ((null? xs) '())
+        ((f (car xs)) (cons (car xs) (keep f (cdr xs))))
+        (#t (keep f (cdr xs)))))
 
-(define (build-sexpr toks)
-  (cond ((null? toks) 
+(define (exc elts n)
+  (cond ((null? elts)
          '())
-        ((eqv? (car toks) #\.)
-         (cons (chars->value (cadr toks)) 
-               (build-sexpr (cddr toks))))
-        ((eqv? (car toks) #\!)
-         (cons (list 'quote (chars->value (cadr toks)))
-               (build-sexpr (cddr toks))))
+        ((eqv? (car elts) #\_)
+         (cons (string->symbol (string-append "v" (number->string n)))
+               (exc (cdr elts) (+ n 1))))
         (#t
-         (cons (chars->value (car toks))
-               (build-sexpr (cdr toks))))))
-                      
+         (cons (car elts) (exc (cdr elts) n)))))
+
+(define (expand-sexpr sym)
+  (build-sexpr (reverse (tokens (lambda (c) (or (eqv? c #\.) (eqv? c #\!)))
+                                (symbol->chars sym)
+                                '()
+                                '()
+                                #t))
+               sym))
+
+(define (build-sexpr toks orig)
+  (cond ((null? toks)
+         'get)
+        ((null? (cdr toks))
+         (chars->value (car toks)))
+        (#t
+         (list (build-sexpr (cddr toks) orig)
+               (if (eqv? (cadr toks) #\!)
+                   (list 'quote (chars->value (car toks)))
+                   (if (or (eqv? (car toks) #\.) (eqv? (car toks) #\!))
+                       (err "Bad ssyntax" orig)
+                       (chars->value (car toks))))))))
 
 (define (insym? char sym) (member char (symbol->chars sym)))
 
@@ -147,17 +152,18 @@
 
 (define (chars->value chars) (read-from-string (list->string chars)))
 
-; result will contain || if separator at end of symbol; could use
-; that to mean something
-
 (define (tokens test source token acc keepsep?)
   (cond ((null? source)
-         (reverse (cons (reverse token) acc)))
+         (reverse (if (pair? token) 
+                      (cons (reverse token) acc)
+                      acc)))
         ((test (car source))
          (tokens test
                  (cdr source)
                  '()
-                 (let ((rec (cons (reverse token) acc)))
+                 (let ((rec (if (null? token)
+                            acc
+                            (cons (reverse token) acc))))
                    (if keepsep?
                        (cons (car source) rec)
                        rec))
@@ -178,7 +184,6 @@
         ((null? (cdr fns)) (cons (car fns) args))
         (#t (list (car fns) (decompose (cdr fns) args)))))
 
-
 (define (ac-global-name s)
   (string->symbol (string-append "_" (symbol->string s))))
 
@@ -195,6 +200,7 @@
 ; process the argument of a quasiquote. keep track of
 ; depth of nesting. handle unquote only at top level (level = 1).
 ; complete form, e.g. x or (fn x) or (unquote (fn x))
+
 (define (ac-qq1 level x env)
   (cond ((= level 0)
          (ac x env))
@@ -219,21 +225,33 @@
   (cond ((null? args) ''nil)
         ((null? (cdr args)) (ac (car args) env))
         (#t `(if (not (ar-false? ,(ac (car args) env)))
-;(not (eq? 'nil ,(ac (car args) env)))
                  ,(ac (cadr args) env)
                  ,(ac-if (cddr args) env)))))
 
+(define (ac-dbname! name env)
+  (if (symbol? name)
+      (cons (list name) env)
+      env))
+
+(define (ac-dbname env)
+  (cond ((null? env) #f)
+        ((pair? (car env)) (caar env))
+        (#t (ac-dbname (cdr env)))))
+
 ; translate fn directly into a lambda if it has ordinary
 ; parameters, otherwise use a rest parameter and parse it.
+
 (define (ac-fn args body env)
   (if (ac-complex-args? args)
       (ac-complex-fn args body env)
-      `(lambda ,(let ((a (ac-denil args))) (if (eqv? a 'nil) '() a))
-         'nil
-         ,@(ac-body body (append (ac-arglist args) env)))))
+      (ac-nameit
+       (ac-dbname env)
+       `(lambda ,(let ((a (ac-denil args))) (if (eqv? a 'nil) '() a))
+          ,@(ac-body* body (append (ac-arglist args) env))))))
 
 ; does an fn arg list use optional parameters or destructuring?
 ; a rest parameter is not complex
+
 (define (ac-complex-args? args)
   (cond ((eqv? args '()) #f)
         ((symbol? args) #f)
@@ -246,13 +264,13 @@
 ; arguments in top-level list are mandatory (unless optional),
 ; but it's OK for parts of a list you're destructuring to
 ; be missing.
+
 (define (ac-complex-fn args body env)
   (let* ((ra (ar-gensym))
          (z (ac-complex-args args env ra #t)))
     `(lambda ,ra
        (let* ,z
-         'nil
-         ,@(ac-body body (append (ac-complex-getargs z) env))))))
+         ,@(ac-body* body (append (ac-complex-getargs z) env))))))
 
 ; returns a list of two-element lists, first is variable name,
 ; second is (compiled) expression. to be used in a let.
@@ -260,6 +278,7 @@
 ; ra is the rest argument to the fn.
 ; is-params indicates that args are function arguments
 ;   (not destructuring), so they must be passed or be optional.
+
 (define (ac-complex-args args env ra is-params)
   (cond ((or (eqv? args '()) (eqv? args 'nil)) '())
         ((symbol? args) (list (list args ra)))
@@ -287,15 +306,18 @@
 
 ; (car ra) is the argument
 ; so it's not present if ra is nil or '()
+
 (define (ac-complex-opt var expr env ra)
   (list (list var `(if (pair? ,ra) (car ,ra) ,(ac expr env)))))
 
 ; extract list of variables from list of two-element lists.
+
 (define (ac-complex-getargs a)
   (map (lambda (x) (car x)) a))
 
 ; (a b . c) -> (a b c)
 ; a -> (a)
+
 (define (ac-arglist a)
   (cond ((null? a) '())
         ((symbol? a) (list a))
@@ -303,9 +325,14 @@
         (#t (cons (car a) (ac-arglist (cdr a))))))
 
 (define (ac-body body env)
+  (map (lambda (x) (ac x env)) body))
+
+; like ac-body, but spits out a nil expression if empty
+
+(define (ac-body* body env)
   (if (null? body)
-      '()
-      (cons (ac (car body) env) (ac-body (cdr body) env))))
+      (list (list 'quote 'nil))
+      (ac-body body env)))
 
 ; (set v1 expr1 v2 expr2 ...)
 
@@ -315,36 +342,82 @@
 (define (ac-setn x env)
   (if (null? x)
       '()
-      (cons (ac-set1 (ac-macex (car x)) (ac (cadr x) env) env)
+      (cons (ac-set1 (ac-macex (car x)) (cadr x) env)
             (ac-setn (cddr x) env))))
 
+; trick to tell Scheme the name of something, so Scheme
+; debugging and profiling make more sense.
+
+(define (ac-nameit name v)
+  (if (symbol? name)
+      (let ((n (string->symbol (string-append " " (symbol->string name)))))
+        (list 'let `((,n ,v)) n))
+      v))
+
 ; = replaced by set, which is only for vars
 ; = now defined in arc (is it?)
 ; name is to cause fns to have their arc names for debugging
 
-(define (ac-set1 a b env)
+(define (ac-set1 a b1 env)
   (if (symbol? a)
-      (let ((name (string->symbol (string-append " " (symbol->string a)))))
-        (list 'let `((,name ,b))
+      (let ((b (ac b1 (ac-dbname! a env))))
+        (list 'let `((zz ,b))
                (cond ((eqv? a 'nil) (err "Can't rebind nil"))
                      ((eqv? a 't) (err "Can't rebind t"))
-                     ((lex? a env) `(set! ,a ,name))
+                     ((lex? a env) `(set! ,a zz))
                      (#t `(namespace-set-variable-value! ',(ac-global-name a) 
-                                                         ,name)))
-               name))
+                                                         zz)))
+               'zz))
       (err "First arg to set must be a symbol" a)))
+
+; given a list of Arc expressions, return a list of Scheme expressions.
+; for compiling passed arguments.
+
+(define (ac-args names exprs env)
+  (if (null? exprs)
+      '()
+      (cons (ac (car exprs)
+                (ac-dbname! (if (pair? names) (car names) #f) env))
+            (ac-args (ar-xcdr names) (cdr exprs) env))))
+
+; generate special fast code for ordinary two-operand
+; calls to the following functions. this is to avoid
+; calling e.g. ar-is with its &rest and apply.
+
+(define ac-binaries
+  '((is ar-is2)
+    (< ar-<2)
+    (> ar->2)
+    (+ ar-+2)))
+
+; (foo bar) where foo is a global variable bound to a procedure.
+
+(define (ac-global-call fn args env)
+  (cond ((and (assoc fn ac-binaries) (= (length args) 2))
+         `(,(cadr (assoc fn ac-binaries)) ,@(ac-args '() args env)))
+        (#t 
+         `(,(ac-global-name fn) ,@(ac-args '() args env)))))
       
 ; compile a function call
 ; special cases for speed, to avoid compiled output like
 ;   (ar-apply _pr (list 1 2))
 ; which results in 1/2 the CPU time going to GC. Instead:
 ;   (ar-funcall2 _pr 1 2)
+; and for (foo bar), if foo is a reference to a global variable,
+;   and it's bound to a function, generate (foo bar) instead of
+;   (ar-funcall1 foo bar)
+
+(define direct-calls #f)
+
 (define (ac-call fn args env)
   (let ((macfn (ac-macro? fn)))
     (cond (macfn
            (ac-mac-call macfn args env))
           ((and (pair? fn) (eqv? (car fn) 'fn))
-           `(,(ac fn env) ,@(map (lambda (x) (ac x env)) args)))
+           `(,(ac fn env) ,@(ac-args (cadr fn) args env)))
+          ((and (symbol? fn) (not (lex? fn env)) (bound? fn)
+                (procedure? (namespace-variable-value (ac-global-name fn))))
+           (ac-global-call fn args env))
           ((= (length args) 0)
            `(ar-funcall0 ,(ac fn env) ,@(map (lambda (x) (ac x env)) args)))
           ((= (length args) 1)
@@ -412,6 +485,7 @@
       (ac-denil x)))
 
 ; is v lexically bound?
+
 (define (lex? v env)
   (memq v env))
 
@@ -420,24 +494,38 @@
 
 ; #f and '() -> nil for a whole quoted list/tree.
 
+; Arc primitives written in Scheme should look like:
+
+; (xdef foo (lambda (lst)
+;           (ac-niltree (scheme-foo (ar-nil-terminate lst)))))
+
+; That is, Arc lists are NIL-terminated. When calling a Scheme
+; function that treats an argument as a list, call ar-nil-terminate
+; to change NIL to '(). When returning any data created by Scheme
+; to Arc, call ac-niltree to turn all '() into NIL.
+; (hash-table-get doesn't use its argument as a list, so it doesn't
+; need ar-nil-terminate).
+
 (define (ac-niltree x)
   (cond ((pair? x) (cons (ac-niltree (car x)) (ac-niltree (cdr x))))
         ((or (eq? x #f) (eq? x '())) 'nil)
         (#t x)))
 
-;(define (err msg . args)
-;  (display msg)
-;  (map (lambda (a) (display " ") (write a))  args)
-;  (newline)
-;  (xxundefined))
-
-(define err error)  ; eli says need to remove xxundefined for speed
+(define err error)
 
 ; run-time primitive procedures
 
-(define (xdef a b)
-  (namespace-set-variable-value! (ac-global-name a) b)
-  b)
+;(define (xdef a b)
+;  (namespace-set-variable-value! (ac-global-name a) b)
+;  b)
+
+(define-syntax xdef
+  (syntax-rules ()
+    ((xxdef a b)
+     (let ((nm (ac-global-name 'a))
+           (a b))
+       (namespace-set-variable-value! nm a)
+       a))))
 
 (define fn-signatures (make-hash-table 'equal))
 
@@ -449,7 +537,7 @@
   (hash-table-put! fn-signatures a (list parms))
   b)
 
-(xdef 'sig fn-signatures)
+(xdef sig fn-signatures)
 
 ; versions of car and cdr for parsing arguments for optional
 ; parameters, that yield nil for nil. maybe we should use
@@ -479,32 +567,42 @@
 (define (ar-false? x)
   (or (eq? x 'nil) (eq? x '()) (eq? x #f)))
 
-#|
-   (if (eq? x 'nil) #t
-      (if (eq? x '()) #t
-          (not x)))
-|#
-
 ; call a function or perform an array ref, hash ref, &c
 
-; Non-fn donstants in functional position are valuable real estate, so
-; should figure out the best way to exploit it.
+; Non-fn constants in functional position are valuable real estate, so
+; should figure out the best way to exploit it.  What could (1 foo) or 
+; ('a foo) mean?  Maybe it should mean currying.
+
+; For now the way to make the default val of a hash table be other than
+; nil is to supply the val when doing the lookup.  Later may also let
+; defaults be supplied as an arg to table.  To implement this, need: an 
+; eq table within scheme mapping tables to defaults, and to adapt the 
+; code in arc.arc that reads and writes tables to read and write their 
+; default vals with them.  To make compatible with existing written tables, 
+; just use an atom or 3-elt list to keep the default.
 
 (define (ar-apply fn args)
-  (cond ((procedure? fn) (apply fn args))
-        ((pair? fn) (list-ref fn (car args)))
-        ((string? fn) (string-ref fn (car args)))
-        ((hash-table? fn) (ar-nill (hash-table-get fn (car args) #f)))
+  (cond ((procedure? fn) 
+         (apply fn args))
+        ((pair? fn) 
+         (list-ref fn (car args)))
+        ((string? fn) 
+         (string-ref fn (car args)))
+        ((hash-table? fn) 
+         (ar-nill (hash-table-get fn 
+                                  (car args) 
+                                  (if (pair? (cdr args)) (cadr args) #f))))
 ; experiment: means e.g. [1] is a constant fn
 ;       ((or (number? fn) (symbol? fn)) fn)
 ; another possibility: constant in functional pos means it gets 
 ; passed to the first arg, i.e. ('kids item) means (item 'kids).
         (#t (err "Function call on inappropriate object" fn args))))
 
-(xdef 'apply (lambda (fn . args)
+(xdef apply (lambda (fn . args)
                (ar-apply fn (ar-apply-args args))))
 
 ; special cases of ar-apply for speed and to avoid consing arg lists
+
 (define (ar-funcall0 fn)
   (if (procedure? fn)
       (fn)
@@ -550,44 +648,52 @@
         ((null? (cdr args)) (ar-nil-terminate (car args)))
         (#t (cons (car args) (ar-apply-args (cdr args))))))
 
-(xdef 'cons cons)
+(xdef cons cons)
 
-(xdef 'car (lambda (x)
+(xdef car (lambda (x)
              (cond ((pair? x)     (car x))
                    ((eqv? x 'nil) 'nil)
                    ((eqv? x '())  'nil)
                    (#t            (err "Can't take car of" x)))))
 
-(xdef 'cdr (lambda (x)
+(xdef cdr (lambda (x)
              (cond ((pair? x)     (cdr x))
                    ((eqv? x 'nil) 'nil)
                    ((eqv? x '())  'nil)
                    (#t            (err "Can't take cdr of" x)))))
 
-; reduce? 
+(define (tnil x) (if x 't 'nil))
 
-(define (pairwise pred args base)
-  (let ((n (length args)))
-    (cond ((< n 2) base)
-          ((= n 2) (apply pred args))
-          (#t (and (pred (car args) (cadr args))
-                   (pairwise pred (cdr args) base))))))
+; (pairwise pred '(a b c d)) =>
+;   (and (pred a b) (pred b c) (pred c d))
+; pred returns t/nil, as does pairwise
+; reduce? 
 
-(define (tnil x) (if x 't 'nil))
+(define (pairwise pred lst)
+  (cond ((null? lst) 't)
+        ((null? (cdr lst)) 't)
+        ((not (eqv? (pred (car lst) (cadr lst)) 'nil))
+         (pairwise pred (cdr lst)))
+        (#t 'nil)))
 
 ; not quite right, because behavior of underlying eqv unspecified
 ; in many cases according to r5rs
 ; do we really want is to ret t for distinct strings?
 
-(xdef 'is (lambda args
-            (tnil (or (all (lambda (a) (eqv? (car args) a)) (cdr args))
-                    (and (all string? args)
-                         (apply string=? args))
-                    (all ar-false? args)))))
-
-(xdef 'err err)
-(xdef 'nil 'nil)
-(xdef 't   't)
+; for (is x y)
+
+(define (ar-is2 a b)
+  (tnil (or (eqv? a b)
+            (and (string? a) (string? b) (string=? a b))
+            (and (ar-false? a) (ar-false? b)))))
+
+; for all other uses of is
+
+(xdef is (lambda args (pairwise ar-is2 args)))
+
+(xdef err err)
+(xdef nil 'nil)
+(xdef t   't)
 
 (define (all test seq)
   (or (null? seq) 
@@ -599,7 +705,7 @@
 ; problem with generic +: what to return when no args?
 ; could even coerce based on type of first arg...
 
-(xdef '+ (lambda args
+(xdef + (lambda args
            (cond ((null? args) 0)
                  ((all string? args) 
                   (apply string-append args))
@@ -607,42 +713,43 @@
                   (ac-niltree (apply append (map ar-nil-terminate args))))
                  (#t (apply + args)))))
 
-(xdef '- -)
-(xdef '* *)
-(xdef '/ /)
-(xdef 'mod modulo)
-(xdef 'expt expt)
-(xdef 'sqrt sqrt)
+(define (ar-+2 x y)
+  (cond ((and (string? x) (string? y))
+         (string-append x y))
+        ((and (arc-list? x) (arc-list? y))
+         (ac-niltree (append (ar-nil-terminate x) (ar-nil-terminate y))))
+        (#t (+ x y))))
+
+(xdef - -)
+(xdef * *)
+(xdef / /)
+(xdef mod modulo)
+(xdef expt expt)
+(xdef sqrt sqrt)
 
 ; generic comparison
 
-(define (arc> . args)
-  (cond ((all number? args) (apply > args))
-        ((all string? args) (pairwise string>? args #f))
-        ((all symbol? args) (pairwise (lambda (x y)
-                                        (string>? (symbol->string x) 
-                                                  (symbol->string y)))
-                                      args
-                                      #f))
-        ((all char?   args) (pairwise char>?   args #f))
-        (#t                 (apply > args))))
-
-(xdef '>  (lambda args (tnil (apply arc> args))))
-
-(define (arc< . args)
-  (cond ((all number? args) (apply < args))
-        ((all string? args) (pairwise string<? args #f))
-        ((all symbol? args) (pairwise (lambda (x y)
-                                        (string<? (symbol->string x) 
-                                                  (symbol->string y)))
-                                      args
-                                      #f))
-        ((all char?   args) (pairwise char<?   args #f))
-        (#t                 (apply < args))))
+(define (ar->2 x y)
+  (tnil (cond ((and (number? x) (number? y)) (> x y))
+              ((and (string? x) (string? y)) (string>? x y))
+              ((and (symbol? x) (symbol? y)) (string>? (symbol->string x)
+                                                       (symbol->string y)))
+              ((and (char? x) (char? y)) (char>? x y))
+              (#t (> x y)))))
+
+(xdef > (lambda args (pairwise ar->2 args)))
+
+(define (ar-<2 x y)
+  (tnil (cond ((and (number? x) (number? y)) (< x y))
+              ((and (string? x) (string? y)) (string<? x y))
+              ((and (symbol? x) (symbol? y)) (string<? (symbol->string x)
+                                                       (symbol->string y)))
+              ((and (char? x) (char? y)) (char<? x y))
+              (#t (< x y)))))
 
-(xdef '<  (lambda args (tnil (apply arc< args))))
+(xdef < (lambda args (pairwise ar-<2 args)))
 
-(xdef 'len (lambda (x)
+(xdef len (lambda (x)
              (cond ((string? x) (string-length x))
                    ((hash-table? x) (hash-table-count x))
                    (#t (length (ar-nil-terminate x))))))
@@ -654,7 +761,7 @@
   (cond ((eqv? (ar-type rep) type) rep)
         (#t (vector 'tagged type rep))))
 
-(xdef 'annotate ar-tag)
+(xdef annotate ar-tag)
 
 ; (type nil) -> sym
 
@@ -675,14 +782,14 @@
         ((exn? x)           'exception)
         ((thread? x)        'thread)
         (#t                 (err "Type: unknown type" x))))
-(xdef 'type ar-type)
+(xdef type ar-type)
 
 (define (ar-rep x)
   (if (ar-tagged? x)
       (vector-ref x 2)
       x))
 
-(xdef 'rep ar-rep)
+(xdef rep ar-rep)
 
 ; currently rather a joke: returns interned symbols
 
@@ -692,44 +799,35 @@
   (set! ar-gensym-count (+ ar-gensym-count 1))
   (string->symbol (string-append "gs" (number->string ar-gensym-count))))
 
-(xdef 'uniq ar-gensym)
+(xdef uniq ar-gensym)
 
-(xdef 'ccc call-with-current-continuation)
+(xdef ccc call-with-current-continuation)
 
-(xdef 'infile  open-input-file)
+(xdef infile  open-input-file)
 
-(xdef 'outfile (lambda (f . args) 
+(xdef outfile (lambda (f . args) 
                  (open-output-file f 
                                    'text
                                    (if (equal? args '(append))
                                        'append
                                        'truncate))))
 
-(xdef 'instring  open-input-string)
-(xdef 'outstring open-output-string)
+(xdef instring  open-input-string)
+(xdef outstring open-output-string)
 
 ; use as general fn for looking inside things
 
-(xdef 'inside get-output-string)
+(xdef inside get-output-string)
 
-(xdef 'close (lambda args
-               (map (lambda (p)
-                      (cond ((input-port? p)   (close-input-port p))
-                            ((output-port? p)  (close-output-port p))
-                            ((tcp-listener? p) (tcp-close p))
-                            (#t (err "Can't close " p))))
-                    args)
-               'nil))
-
-(xdef 'stdout current-output-port)  ; should be a vars
-(xdef 'stdin  current-input-port) 
-(xdef 'stderr current-error-port)
+(xdef stdout current-output-port)  ; should be a vars
+(xdef stdin  current-input-port) 
+(xdef stderr current-error-port)
 
-(xdef 'call-w/stdout
+(xdef call-w/stdout
       (lambda (port thunk)
         (parameterize ((current-output-port port)) (thunk))))
 
-(xdef 'call-w/stdin
+(xdef call-w/stdin
       (lambda (port thunk)
         (parameterize ((current-input-port port)) (thunk))))
 
@@ -737,56 +835,58 @@
 ; nil stream means stdout
 ; returns nil on eof
 
-(xdef 'readc (lambda (str) 
+(xdef readc (lambda (str) 
                (let ((p (if (ar-false? str)
                             (current-input-port)
                             str)))
                  (let ((c (read-char p)))
                    (if (eof-object? c) 'nil c)))))
 
-(xdef 'readb (lambda (str)
+(xdef readb (lambda (str)
                (let ((p (if (ar-false? str)
                             (current-input-port)
                             str)))
                  (let ((c (read-byte p)))
                    (if (eof-object? c) 'nil c)))))
 
-(xdef 'peekc (lambda (str) 
+(xdef peekc (lambda (str) 
                (let ((p (if (ar-false? str)
                             (current-input-port)
                             str)))
                  (let ((c (peek-char p)))
                    (if (eof-object? c) 'nil c)))))
 
-(xdef 'writec (lambda (c . args) 
+(xdef writec (lambda (c . args) 
                 (write-char c 
                             (if (pair? args) 
                                 (car args) 
                                 (current-output-port)))
                 c))
 
-(xdef 'writeb (lambda (b . args) 
+(xdef writeb (lambda (b . args) 
                 (write-byte b 
                             (if (pair? args) 
                                 (car args) 
                                 (current-output-port)))
                 b))
 
+(define explicit-flush #f)
+
 (define (printwith f args)
   (let ((port (if (> (length args) 1)
                   (cadr args)
                   (current-output-port))))
     (when (pair? args)
       (f (ac-denil (car args)) port))
-    (flush-output port))
-    'nil)
+    (unless explicit-flush (flush-output port)))
+  'nil)
 
-(xdef 'write (lambda args (printwith write   args)))
-(xdef 'disp  (lambda args (printwith display args)))
+(xdef write (lambda args (printwith write   args)))
+(xdef disp  (lambda args (printwith display args)))
 
 ; sread = scheme read. eventually replace by writing read
 
-(xdef 'sread (lambda (p eof)
+(xdef sread (lambda (p eof)
                (let ((expr (read p)))
                  (if (eof-object? expr) eof expr))))
 
